/*
 * Copyright (C) 2022  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#include "src/impl/collect_data/util/add_old_new_pair_if_different.hh"

namespace Fred {
namespace Notify {
namespace ObjectEvents {
namespace Impl {
namespace CollectData {
namespace Util {

/**
 * if _old != _new
 *      insert pair("changes." _key ".old", _old) to _target
 *      insert pair("changes." _key ".new", _new) to _target
 */
void add_old_new_changes_pair_if_different(
        LibHermes::Struct& _target,
        const LibHermes::StructKey& _key,
        const std::string& _old,
        const std::string& _new)
{
    if (_old != _new)
    {
        _target.emplace(
                _key,
                LibHermes::StructValue{LibHermes::Struct{
                        {LibHermes::StructKey{"old"}, LibHermes::StructValue{_old}},
                        {LibHermes::StructKey{"new"}, LibHermes::StructValue{_new}}}});
    }
}

} // namespace Fred::Notify::ObjectEvents::Impl::CollectData::Util
} // namespace Fred::Notify::ObjectEvents::Impl::CollectData
} // namespace Fred::Notify::ObjectEvents::Impl
} // namespace Fred::Notify::ObjectEvents
} // namespace Fred::Notify
} // namespace Fred
